<?php

defined('_VALID_CALL') or die('Direct Access is not allowed.');

global $db;

$db->Execute("DELETE FROM ".TABLE_ADMIN_NAVIGATION." WHERE text in ('xt_blog','xt_blog_messages','xt_blog_categories','xt_blog_comments')");
$db->Execute("INSERT INTO ".TABLE_ADMIN_NAVIGATION." (`pid` ,`text` ,`icon` ,`url_i` ,`url_d` ,`sortorder` ,`parent` ,`type` ,`navtype`) VALUES (NULL , 'xt_blog', 'images/icons/feed.png', '', '', '4000', 'shop', 'G', 'W');");
$db->Execute("INSERT INTO ".TABLE_ADMIN_NAVIGATION." (`pid` ,`text` ,`icon` ,`url_i` ,`url_d` ,`sortorder` ,`parent` ,`type` ,`navtype`) VALUES (NULL , 'xt_blog_messages', 'images/icons/page.png', '&plugin=xt_blog&load_section=xt_blog_messages', 'adminHandler.php', '4010', 'xt_blog', 'I', 'W');");
$db->Execute("INSERT INTO ".TABLE_ADMIN_NAVIGATION." (`pid` ,`text` ,`icon` ,`url_i` ,`url_d` ,`sortorder` ,`parent` ,`type` ,`navtype`) VALUES (NULL , 'xt_blog_categories', 'images/icons/folder.png', '&plugin=xt_blog&load_section=xt_blog_categories', 'adminHandler.php', '4020', 'xt_blog', 'I', 'W');");
$db->Execute("INSERT INTO ".TABLE_ADMIN_NAVIGATION." (`pid` ,`text` ,`icon` ,`url_i` ,`url_d` ,`sortorder` ,`parent` ,`type` ,`navtype`) VALUES (NULL , 'xt_blog_comments', 'images/icons/comments.png', '&plugin=xt_blog&load_section=xt_blog_comments', 'adminHandler.php', '4030', 'xt_blog', 'I', 'W');");


$db->Execute("
CREATE TABLE IF NOT EXISTS ".DB_PREFIX."_blog_categories (
  blog_categories_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  parent_id INTEGER UNSIGNED NULL,
  categorie_status TINYINT UNSIGNED NULL,
  sort_order INTEGER UNSIGNED NULL,
  author VARCHAR(255) CHARACTER SET utf8mb4 NULL DEFAULT NULL,
  PRIMARY KEY(blog_categories_id)
) DEFAULT CHARSET=utf8;
");

$db->Execute("
CREATE TABLE IF NOT EXISTS ".DB_PREFIX."_blog_kommentar (
 `blog_kommentar_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
 `ref_blog_message` INT(10) UNSIGNED NULL DEFAULT NULL,
 `username` VARCHAR(255) NULL DEFAULT NULL,
 `added_date` DATETIME NULL DEFAULT NULL,
 `message` TEXT CHARACTER SET utf8mb4 NULL DEFAULT NULL,
 `public_status` TINYINT(3) UNSIGNED NULL DEFAULT NULL,
 `public_date` DATETIME NULL DEFAULT NULL,
 `accept_key` varchar(32) NULL DEFAULT NULL,
  PRIMARY KEY(blog_kommentar_id)
) DEFAULT CHARSET=utf8;
");

$db->Execute("
CREATE TABLE IF NOT EXISTS ".DB_PREFIX."_blog_message (
  blog_message_id INTEGER UNSIGNED NOT NULL AUTO_INCREMENT,
  guid VARCHAR(50) NULL DEFAULT NULL,
  created_date DATETIME NULL,
  public_start_date DATETIME NULL,
  public_stop_date DATETIME NULL,
  public_status TINYINT UNSIGNED NULL,
  twitter_status TINYINT UNSIGNED NULL,
  twitter_id VARCHAR(20) NULL DEFAULT NULL,
  archive_status TINYINT UNSIGNED NULL,
  featured TINYINT UNSIGNED NULL,
  author VARCHAR(255) CHARACTER SET utf8mb4 NULL DEFAULT NULL,
  PRIMARY KEY(blog_message_id)
) DEFAULT CHARSET=utf8;
");

$db->Execute(" 
CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_blog_categories_description` (
    `blog_categories_id` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    `language_code` CHAR(2) NOT NULL,
    `blog_categorie_name` VARCHAR(255) CHARACTER SET utf8mb4 NULL DEFAULT NULL,
    PRIMARY KEY (`blog_categories_id`, `language_code`)
) DEFAULT CHARSET=utf8;
");  

$db->Execute(" 
CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_blog_message_categories` (
    `pk` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    `blog_message_id` INT(10) UNSIGNED NULL DEFAULT NULL,
    `blog_categories_id` INT(10) UNSIGNED NULL DEFAULT NULL,
    `allow` TINYINT(3) UNSIGNED NULL DEFAULT NULL,
    PRIMARY KEY (`pk`)
) DEFAULT CHARSET=utf8;
");

$db->Execute(" 
CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_blog_pages` (
    `pk` INT(10) UNSIGNED NOT NULL AUTO_INCREMENT,
    `blog_message_id` INT(10) UNSIGNED NULL DEFAULT NULL,
    `blog_page` VARCHAR(150) CHARACTER SET utf8mb4 NULL DEFAULT NULL,
    PRIMARY KEY (`pk`)
) DEFAULT CHARSET=utf8;
");

$db->Execute("
CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_blog_message_description` (
  `blog_message_id` INTEGER UNSIGNED NOT NULL,
  `language_code` CHAR(2) NOT NULL,
  `title` VARCHAR(200) CHARACTER SET utf8mb4 NULL DEFAULT NULL,
  `message` TEXT CHARACTER SET utf8mb4 NULL DEFAULT NULL,
  `message_long` TEXT CHARACTER SET utf8mb4 NULL DEFAULT NULL,
  PRIMARY KEY (`blog_message_id`,`language_code`)
) DEFAULT CHARSET=utf8;
");

$db->Execute("   
  INSERT INTO `".DB_PREFIX."_blog_pages` (`blog_message_id`, `blog_page`) VALUES ('0', 'BLOG') ;
");
if (!$this->_FieldExists('internal_status', DB_PREFIX . '_mail_templates'))
{
    $db->Execute(" ALTER TABLE  `".DB_PREFIX."_mail_templates` ADD  `internal_status` INT( 1 ) NULL DEFAULT  '0'");
}
 	
$db->Execute("
CREATE TABLE IF NOT EXISTS `".DB_PREFIX."_blog_message_cross_sell` (
  `blog_message_id` int(11) NOT NULL,
  `products_id_cross_sell` int(11) NOT NULL,
  UNIQUE KEY `blog_message_id` (`blog_message_id`,`products_id_cross_sell`)
) DEFAULT CHARSET=utf8;
");

/* Set SEO data for plugin */
$seo_plugin_file = _SRV_WEBROOT.'/xtFramework/classes/class.seo_plugins.php';
if (file_exists($seo_plugin_file))
{
	require_once $seo_plugin_file;
	
	 $seo_plugin = new seo_plugins();
	 $seo_plugin->setPluginSEO('xt_blog');
}

$langs = array('de','en');
$tpls = array('blog_mail-accept');
$mail_dir = _SRV_WEBROOT.'plugins/xt_blog/installer/mails/';
_installMailTemplates($langs, $tpls, $mail_dir);

function _installMailTemplates($langs, $tpls, $mail_dir) {
    global $db;

    foreach($tpls as $tpl)
    {
        $data = array(
            'tpl_type' => $tpl,
            'tpl_special' => '-1',
        );
        $c = (int) $db->GetOne("SELECT count(tpl_id) FROM ".TABLE_MAIL_TEMPLATES." where `tpl_type` = '".$data['tpl_type']."'");
        if ($c>0)
        {
            continue;
        }
        try {
            $db->AutoExecute(TABLE_MAIL_TEMPLATES ,$data);
        } catch (exception $e) {
            return $e->getMessage();
        }
        $tplId = $db->GetOne("SELECT `tpl_id` FROM `".TABLE_MAIL_TEMPLATES."` WHERE `tpl_type`='".$data['tpl_type']."'");

        foreach($langs as $lang)
        {
            $html = file_exists($mail_dir.$lang.'/'.$tpl.'_html.txt') ?  _getFileContent($mail_dir.$lang.'/'.$tpl.'_html.txt') : '';
            $txt = file_exists($mail_dir.$lang.'/'.$tpl.'_txt.txt') ?  _getFileContent($mail_dir.$lang.'/'.$tpl.'_txt.txt') : '';
            $subject = file_exists($mail_dir.$lang.'/'.$tpl.'_subject.txt') ?  _getFileContent($mail_dir.$lang.'/'.$tpl.'_subject.txt') : '';

            $data = array(
                'tpl_id' => $tplId,
                'language_code' => $lang,
                'mail_body_html' => $html,
                'mail_body_txt' => $txt,
                'mail_subject' => $subject,
            );
            try {
                $db->AutoExecute(TABLE_MAIL_TEMPLATES_CONTENT ,$data);
            } catch (exception $e) {
                return $e->getMessage();
            }
        }
    }
}

function _getFileContent($filename)
{
    $handle = fopen($filename, 'rb');
    $content = fread($handle, filesize($filename));
    fclose($handle);
    return $content;
}
